/***************************************************************************
                          prototypeview.h  -  description
                             -------------------
    begin                : Thu May 15 22:50:15 CEST 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PROTOTYPEVIEW_H
#define PROTOTYPEVIEW_H

#define PROTOCOL_SHOW_TYPICAL 0
#define PROTOCOL_SHOW_ALL 1


// include files for QT
#include <qwidget.h>

// application specific includes
#include "prototypedoc.h"
#include "viewplugin.h"


#include <qpainter.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class QFrame;
class QLabel;
class QListBox;
class QListBoxItem;
class QPushButton;
class QSplitter;
class QTextEdit;
class QHBox;
class QScrollView;
class QColor;
class BlockBtn;
class Block;
class BlockList;
class QMainWindow;
class QCanvas;
class QCanvasView;


/**
 * This class provides an incomplete base for your application view. 
 */

class ProtoTypeView : public QWidget
{
	Q_OBJECT

public:
	ProtoTypeView(QWidget *parent=0, ProtoTypeDoc* doc=0);
	~ProtoTypeView();

	QSplitter* splitter1;
	QListBox* listBox2;
	QFrame* frame4;
	QSplitter* splitter3;
	QScrollView* frame5;
	QScrollView* tree;
	QPushButton* pushButton1;
	QFrame* frame6;
	QLabel* textLabel1;
	QLabel* textLabel2;
	QLabel* textLabel3;
	QLabel* textLabel4;
	QTextEdit* textEdit1;
	QHBox* blockbox;
	QHBox* infobox;
	QHBox* sequencebox;
	QHBox* treebox;
	ViewPlugin* plugindisplay;
	QLabel* followslabel;
	QLabel* followedbylabel;

	void addProtocol( QString p );
	void clearProtocolList();
	void setDoc( ProtoTypeDoc* d );
	enum ShowState { ShowTypical=1, ShowAll=2 };
	QTextEdit* getTextEdit();
	QString getCurrentBlockName();
	QString getCurrentProtocol();
	void setCurrentProtocol(QString p);
	void launchPlugin( QString pl );
	ViewPlugin* loadPlugin( QString pluginlib, QWidget* par );
	void initPlugin( ViewPlugin* plugin );
	

signals:
	void protocolSelected( QString protocol );

public slots:
	virtual void loadBlocks( QListBoxItem* item );
	virtual void setShowState( ShowState s );
	void setTreeView( bool on );

protected slots:
	void slotDocumentChanged();
	void showBlockDescription( int id );
	void parseTree( BlockList* bl, Block* b, ShowState show = ShowTypical );
	void unloadPlugin( ViewPlugin* plug );


protected:
	QHBoxLayout* ProtoTypeLayout;
	QVBoxLayout* frame4Layout;
	QVBoxLayout* frame6Layout;
	QHBoxLayout* treeLayout;
	void garbageCollect();

private:
	QColor colorChooser(int c);
	ProtoTypeDoc* doc;
	QPtrList<BlockBtn> buttonlist;
	QPtrList<BlockBtn> buttonlist2;
	ShowState state;
	QString currentBlockName;
	QString currentProtocol;
	QMainWindow *mw;
	QMainWindow *mw2;	
	QFrame* canvas;
	QCanvas* lines;
	QCanvasView* linesview;
	QPainter painter;
	int treeview_y_coord;
	int treeview_x_coord;
	int max_button_width;
	int max_button_height;
	int max_x;
	int max_y;
	int spacex;
	int spacey;
	
	int col;
	int row;
	
	int newID;
	
	QPtrList<ViewPlugin> pluglist;
	QPtrList<QMainWindow> winlist;
	
	void* backendlib;
	create_t*  create_plug;
	destroy_t* destroy_plug;
	
		
};

#endif
