/***************************************************************************
                          viewplugin.cpp  -  description
                             -------------------
    begin                : Sat May 31 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "viewplugin.h"

#include "blocklist.h"
#include "block.h"

ViewPlugin::ViewPlugin(QWidget *parent, const char *name ) : QWidget(parent,name)
{
  	bl = new BlockList();
}



ViewPlugin::~ViewPlugin()
{
  
}



/** This method is used to reset the protocol-display of the plugin. */
void ViewPlugin::clear()
{
  
}


/** This method is used to inititalize the display of the typical or complete view of the protocol... */
void ViewPlugin::init( ShowState show)
{
  
}



void ViewPlugin::addBlock(Block * block)
{
	  bl->append(  new Block( *block)  );
}

void ViewPlugin::addBlockFollowedby(int blockid, int followerid)
{
	int z = bl->find( new Block( blockid ) );
	if( z > -1 ){
		Successor* s = new Successor();
		s->ID = followerid;
		Block* b = (Block*) bl->at( z );
		b->addFollowedby( *s );
	}
}

void ViewPlugin::addBlockFollows(int blockid, int followerid)
{
	int z = bl->find( new Block( blockid ) );
	if( z > -1 ){
		Successor* s = new Successor();
		s->ID = followerid;
		Block* b = (Block*) bl->at( z );
		b->addFollows( *s );
	}
}

void ViewPlugin::addBlockTypicalFollowedby(int blockid, int followerid)
{
	int z = bl->find( new Block( blockid ) );
	if( z > -1 ){
		Successor* s = new Successor();
		s->ID = followerid;
		Block* b = (Block*) bl->at( z );
		b->addTypicalFollowedby( *s );
	}
}





